/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.map.Npc
 *  fire.pb.map.SceneNpcManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.MessageUtil
 *  fire.pb.util.TaskDlgUtil
 *  mkdb.Procedure
 */
package fire.pb.activity.winner;

import fire.pb.PropRole;
import fire.pb.activity.winner.WinnerManager;
import fire.pb.activity.winner.WinnerRecord;
import fire.pb.map.Npc;
import fire.pb.map.SceneNpcManager;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.MessageUtil;
import fire.pb.util.TaskDlgUtil;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import mkdb.Procedure;

public class PReqStartWinner
extends Procedure {
    private final long roleid;
    private final int npccode;

    public PReqStartWinner(long roleid, int npccode) {
        this.roleid = roleid;
        this.npccode = npccode;
    }

    protected boolean process() throws Exception {
        Team team = TeamManager.selectTeamByRoleId((long)this.roleid);
        if (team == null || team.isAbsentMember(this.roleid)) {
            MessageMgr.psendMsgNotify((long)this.roleid, (int)140669, (int)this.npccode, null);
            return false;
        }
        List teamMembers = team.getNormalMemberIds();
        int teamSize = teamMembers.size();
        if (teamSize < 3) {
            for (Long member : teamMembers) {
                MessageMgr.psendMsgNotify((long)member, (int)140669, (int)this.npccode, null);
            }
            return false;
        }
        if (!TeamManager.isTeamLeader((long)this.roleid)) {
            MessageMgr.psendMsgNotify((long)this.roleid, (int)141206, null);
            return false;
        }
        ArrayList<Long> levelLess40 = new ArrayList<Long>();
        for (Long mem : teamMembers) {
            PropRole role = new PropRole(mem.longValue(), true);
            if (role.getLevel() >= 40) continue;
            levelLess40.add(mem);
        }
        if (!levelLess40.isEmpty()) {
            String roleNames = MessageUtil.getRoleNames(levelLess40);
            List paras = MessageUtil.getMsgParaList((String[])new String[]{roleNames});
            for (Long mem : teamMembers) {
                MessageMgr.psendMsgNotify((long)mem, (int)140670, (int)this.npccode, (List)paras);
            }
            return false;
        }
        long teamid = team.teamId;
        if (teamid <= 0L) {
            return false;
        }
        WinnerRecord record = WinnerManager.getInstance().teams.get(teamid);
        if (record == null) {
            record = new WinnerRecord(teamid);
            WinnerManager.getInstance().teams.put(teamid, record);
        }
        if (TaskDlgUtil.existTask((long)this.roleid, (int)701002)) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)144923, (int)this.npccode, null);
            return true;
        }
        if (record.getTeamMembers().size() > 0) {
            for (long rid : record.getTeamMembers().values()) {
                WinnerManager.getInstance().removeLastTeamid(rid);
            }
        }
        record.getTeamMembers().clear();
        for (Long member : teamMembers) {
            record.getTeamMembers().put(member, member);
            WinnerManager.getInstance().winnerRoleidsTeamid.put(member, teamid);
        }
        boolean havafirsttask = TaskDlgUtil.existTask((long)this.roleid, (int)701001);
        if (!WinnerManager.getInstance().isInWinnerActiveTime(record.getStartTime()) || !havafirsttask) {
            record.setTeamScore(0);
            record.setStartTime(System.currentTimeMillis());
            record.setRoundCostTime(Long.MAX_VALUE);
            record.setRound(0);
            record.setAllCostTime(0L);
            record.setTaskstartTime(0L);
            for (Long mem : teamMembers) {
                WinnerManager.clearActiveTeamWinnerScore(mem);
            }
            WinnerManager.logger.info((Object)("重新接取冠军试炼任务,队伍id\t" + record.getTeamid() + "\t当前队伍成员\t" + record.getTeamMembers().values() + "重新设置原因" + havafirsttask));
        }
        record.setLeaderID(this.roleid);
        record.setRoundStartTime(System.currentTimeMillis());
        record.setTaskstartTime(System.currentTimeMillis());
        record.setStageSucc(0);
        List<Integer> stageList = record.getStageList();
        this.genStageList(stageList);
        int firstStage = stageList.get(0);
        for (final Long mem : teamMembers) {
            if (TaskDlgUtil.existTask((long)mem, (int)701001)) {
                Procedure proc = new Procedure(){

                    protected boolean process() throws Exception {
                        TaskDlgUtil.refreshTaskState((long)mem, (int)701001, (int)5);
                        return true;
                    }
                };
                Procedure.pexecuteWhileCommit((Procedure)proc);
            }
            long npckey = WinnerManager.npc_keys.get(firstStage);
            Npc npc = SceneNpcManager.selectNpcByKey((long)npckey);
            WinnerManager.getInstance().createWinnerTask(701002, mem, npc, 4, 0, 1);
            WinnerManager.getInstance().addWinnerRole(mem);
            MessageMgr.psendMsgNotifyWhileCommit((long)mem, (int)140666, (int)this.npccode, Arrays.asList("1", npc.getName()));
        }
        WinnerManager.logger.info((Object)("接取冠军试炼任务,队伍id\t" + record.getTeamid() + "\t当前队伍成员\t" + record.getTeamMembers().values() + "\t当前队伍成绩\t" + record.getTeamScore()));
        return true;
    }

    private void genStageList(List<Integer> stageList) {
        if (!stageList.isEmpty()) {
            stageList.clear();
        }
        for (int i = 1; i < WinnerManager.npc_keys.size(); ++i) {
            stageList.add(i);
        }
        Collections.shuffle(stageList);
    }
}

